<!doctype html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="icon" href="/images/favicon.ico">

    <title>Agent Console</title>

    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@100;300;400;500&display=swap" rel="stylesheet">

    <!-- Bootstrap core CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <link rel="stylesheet" href="/stylesheets/agents.css" type="text/css">

    <!-- Custom styles for this template -->
    <link href="/stylesheets/agents.css" rel="stylesheet">
    <!-- Custom styles for this template -->
    <link href="/stylesheets/conversations.css" rel="stylesheet">
    <!-- <script src="/socket.io/socket.io.js"></script> -->

</head>

<body>
    <!-- Header Start -->
    
    <div class="header">
        <div class="header-wrapper">
            <div class="header-title">Agent Console</div>
            <div class="header-profile">
                <div>
                    <div>Jason Hart</div>
                    <div>Human Resource Manager</div>
                </div>
                <div class="dropdown">
                    <div class="dropdown-toggle dropdown-menu-left" data-toggle="dropdown">JA</div>
                    <ul class="dropdown-menu">
                        <li><a href="#">Edit profile</a></li>
                        <li><a href="#">Account Management</a></li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <!-- Header End -->

    <!-- Chat Container Start -->
    <div class="chat-container chat-fadeIn" id="app"> 
        <!-- Left Section -->
        <div class="chat-list" >
            <div class="chat-search">
                <div>Conversations</div>
                <div>
                    <input type="text" />
                    <i class="fa fa-search"></i>
                </div>
            </div>
            <div class="user-section">
                <div class="sm-title">Live Conversations</div>
                <div class="user-list">
                    <ul>
                        <li @click="updateSelected(item)" v-for="item in conversations_list" :id=item.convo_id>
                            <!-- Users -->
                            <!-- <div>
                                <div>ST</div>
                                <div>
                                    <div>Steffeni</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>California USA</div>
                                </div>
                            </div> -->


                            <div >
                                <!-- <div>{{ item.initials }}</div> -->
                                <div>GM</div>

                                <div>
                                    <div>{{ item.first_name }}</div>
                                    <div> {{item.date}}</div>
                                    <div> {{item.location}}</div>
                                    <!-- <div>{{ item.date }} {{ item.time }}</div>
                                    <div>{{ item.location }}</div> -->
                                </div>
                            </div>


                            <!-- End -->
                        </li>

                        <!-- <li>
                            <div>
                                <div>PR</div>
                                <div>
                                    <div>Priyanka</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>Texas USA</div>
                                </div>
                            </div>
                        </li>
                        <li>
                            <div>
                                <div>RI</div>
                                <div>
                                    <div>Richard</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>NY USA</div>
                                </div>
                            </div>
                        </li>
                        <li>
                            <div>
                                <div>JO</div>
                                <div>
                                    <div>Joseph</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>NY USA</div>
                                </div>
                            </div>
                        </li>
                        <li>
                            <div>
                                <div>ST</div>
                                <div>
                                    <div>Steffeni</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>California USA</div>
                                </div>
                            </div>
                        </li> -->
                    </ul>
                </div>
            </div>
            <div class="user-section no-border">
                <div class="sm-title">New Requests</div>
                <div class="user-list">
                    <ul>
                        <li>
                            <!-- Users -->
                            <!-- <div>
                                <div>ST</div>
                                <div>
                                    <div>Steffeni</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>California USA</div>
                                </div>
                                <button>Accept</button>
                            </div> -->

                            <div v-for="(item,i) in messages_requests" :id=item.convo_id>
                                <div>MG</div>
                                <div>
                                    <div>{{ item.first_name }}</div>
                                    <div> {{item.date}}</div>
                                    <div> {{item.location}}</div>
                                    <!-- <div>{{ item.date }} {{ item.time }}</div>
                                    <div>{{ item.location }}</div> -->

                                </div>
                                <button @click="acceptChat($event,i,item)">Accept</button>
                            </div>
                            <!-- End -->
                        </li>
                        <!-- <li>
                            <div>
                                <div>PR</div>
                                <div>
                                    <div>Priyanka</div>
                                    <div>March 25 2020 8am PST</div>
                                    <div>Texas USA</div>
                                </div>
                                <button>Accept</button>
                            </div>
                        </li> -->
                    </ul>
                </div>
            </div>
        </div>
        <!-- End left Section -->
        <div v-if = "agentConsole" class="chat-panel dashboard-console">
            <p>Welcome to Avaamo Agent Console</p>
            <img src="/assets/images/welcome-icon.svg" />
            <p>Avaamo agent console is a comprehensive chat solution that makes it easy for you to support customers</p>
        </div>
        <!-- Right Section -->
        <div v-if = "!agentConsole" class="chat-panel ">

            <!-- Top section -->
            <div class="top-section">
                <div>
                    <div class="avatar">
                        <img src="/assets/images/avatar-developer.png" />
                        
                    </div>
                    <div class="user-info">
                        <div>Richard</div>
                        <div>March 25 2020 8:10am PST / NY USA</div>
                    </div>
                </div>
                <div>
                    <button @click="closeButton" >Close</button>
                    <i class="fa fa-ellipsis-v"></i>
                </div>
            </div>
            <!-- End Top Section -->

            <!-- Middle Section -->
            <div class="middle-section" >
                <div v-for="msgs in tempMsg">
                    <div v-if = "msgs.type=='sys1'" class="chat-basic chat-type-1">
                        <div>
                            <img width="38" src="/assets/images/support.png" />
                        </div>
                        <div>
                            <div class="chat-info">
                                <div>{{ msgs.msg}}</div>
                                <div>See More Options</div>
                            </div>
                            <div class="chat-time">8:10am</div>
                        </div>
                    </div>

                      <!-- Chat type 2 Start-->
                <div v-if = "msgs.type=='sys'" class="chat-basic chat-type-1 chat-type-2">
                    <div>
                        <img width="38" src="/assets/images/support.png" />
                    </div>
                    <div>
                        <div class="chat-info">
                            <div>{{msgs.msg}}</div>
                        </div>
                        <div class="chat-time">8:10am</div>
                    </div>
                </div>
                <!-- End Chat type 2 -->

                 <!-- Chat type 3 Start-->
                 <div v-if = "msgs.type=='user'" class="chat-basic chat-type-5">
                    <!-- <div>RI</div> -->
                    <div>
                        <div class="chat-info">
                            <div>{{msgs.msg}}</div>
                        </div>
                        <div class="chat-time">8:10am</div>
                    </div>
                </div>
                <!-- End Chat type 3 -->

                 <!-- Chat type 4 Start-->
                 <!-- <div v-if = "msgs.type=='agent'" class="chat-basic chat-type-4">
                    <div>
                        <img width="38" src="/assets/images/connect.png" />
                    </div>
                    <div>
                        <div class="chat-info">
                            <div>HR case CASE - 0133413</div>
                        </div>
                        <div class="chat-time">System Message : 8:11am</div>
                    </div>
                </div> -->
                <!-- End Chat type 4 -->

                    </div>
                <!-- Chat type 1 Start-->
                <!-- <div class="chat-basic chat-type-1">
                    <div>
                        <img width="38" src="/assets/images/support.png" />
                    </div>
                    <div>
                        <div class="chat-info">
                            <div>What can I help you with today?</div>
                            <div>See More Options</div>
                        </div>
                        <div class="chat-time">8:10am</div>
                    </div>
                </div> -->
                <!-- End Chat type 1 -->

               

              

               

                <!-- Chat type 5 Start-->
                <!-- <div class="chat-basic chat-type-5">
                    <div>
                        <div>
                            <div class="chat-info">
                                <div>Hi am Jason how can I help you</div>
                            </div>
                            <div class="chat-time">8:12am</div>
                        </div>
                    </div>
                </div> -->
                <!-- End Chat type 5 -->

                <!-- RAYAN"S CODE -->

                <div id="simpleModal" class="modal1">
                    <div class="modal-content1">
                        <div class="head">
                            <h5>Escalate</h5>
                            <div class="head-btn">
                                <div>
                                    <input type="button" value="Proceed" class="closeBtn1" onclick="">
                               </div>
                                <div>
                                    <input type="button" value="Cancel" class="closeBtn1" id="closeBtn" v-on:click="closeModal">
                                </div>
                            </div>
                           
                        </div>
                        <div class="modal-body">
                            <p>Do you want to escalate the issue to your Senior Official/ Manager</p>
                        </div>
                    </div>
                </div>
            </div> 


            <!-- </div> -->
            <!-- End Middle Section -->

            <!-- Attach Section -->
            <div class="attach-section">
                <button class="files">Attach Files</button>
                <button class="escalate" data-toggle="modal" data-target="#myModal">Escalate</button>
            </div>
            <!-- End Attach Section -->


            <!-- Bottom Section -->

            <!-- RAYAN"S CODE -->
            <div class="bottom-section" id="bottom-section">
                <!-- <div v-bind:style="{display:showdis}" class="attach-menu"> -->
                    <div class="attach-menu">
                    <!-- <button> -->
                        <img v-on:click = "dis" src="/assets/images/menu.png" />
                    <!-- </button> -->
                </div>
                
                <div>
                    <input v-model = "newMessage" type="text" placeholder="Type in a message" />
                </div>
                <div>
                    <img v-on:click="send" src="/assets/images/send.png"/>
                </div>
                <div class="btn_div" id="btn_div">
                    <div id="btn1"> 
                        <button class="button-bottom1">Attach files.</button> 
                    </div>
                    <div id="btn2"> 
                        <button class="button-bottom1" v-on:click="openMod">Escalate.</button>
                    </div>

                </div>
                
            </div> 
            <!-- RAYAN"S CODE END -->

            <!-- ACTUAL CODE -->

            <!-- <div class="bottom-section">
                <div class="attach-menu">
                   
                    <img src="/assets/images/menu.png" />
                    
                    
                </div>
                <div>
                    <input v-model = "newMessage" type="text" placeholder="Type in a message" />
                </div>
                <div>
                    <img v-on:click = "send" src="/assets/images/send.png" />
                    
                </div>
            </div> -->
            <!-- End Bottom Section -->
        </div>
        <!-- End Right Section -->
    </div>
    <!-- Chat Container End -->

    <!-- Modal popup -->
    <div class="modal modal-popup fade" id="myModal" role="dialog">
        <div class="modal-dialog">
            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-body">
                    <div class="modal-btn">
                        <div>Escalate</div>
                        <div>
                            <button data-dismiss="modal">Close</button>
                            <button class="active">Proceed</button>
                        </div>
                    </div>
                    <div class="modal-txt">
                        <div>Do you want to escalate the issue to your Senior Official/ Manager</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- End -->

</body>

<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/3.1.1/socket.io.js"></script>
<script>

    // RAYAN"S CODE
    
    // function dis(){
    //     var btn_div = document.getElementById('btn_div');
    //     console.log("DISPLAY FUNCTION")
    //     btn_div.style.display="flex";
    // }
    // MODAL DISPLAYING

    // function openMod(){
        // console.log("IN OPEN MODAL");
        // document.getElementById('simpleModal').style.display='block';
        // console.log("IN END OF OPEN MODAL");
    // }
    // function closeModal(){
    //     console.log("IN CLOSE MODAL")
    //     document.getElementById('simpleModal').style.display='none';
    // }
 

    // RAYAN"S code END

    // var socket = io('https://63efb6850a23.ngrok.io:3030');
    // var socket = io.connect('wss://63efb6850a23.ngrok.io:3030', {transports:['websocket']});
    var socket = io.connect('wss://ed196e7f8b8f.ngrok.io', { transports: ['websocket'] });
    // socket.emit('message', { 'data': 'hello there' });
    //  test = new Vue({
    //     el:'#test',
    //     data:{
    //         tempMsg :[{'msg':'What can I help you with today?','type':'sys1'},{'msg':'What can I help you with tomorrow?','type':'sys'},{'msg':'Hi, Hello','type':'user'},{'msg':'Agent here','type':'agent'}]
    //     }
    // })
    let vue = new Vue({
        el: '#app',
        data: {
            tempMsg :[{'msg':'What can I help you with today?','type':'sys1'},{'msg':'Hi, Hello','type':'user'},{'msg':'Agent here','type':'agent'}],
            newMessage: null,
            messages: [],
            conversations_list: [],
            messages_requests: [],
            typing: false,
            username: null,
            agentConsole:false,
            info: [],
            connections: 0,
            newRequests: [],
            accountId: '6012a7a69c497f0019500484',
            selectedChat: {},
            display:"none",
            // computed:{
            //     showdis:function(){
            //         return this.display
            //     }
            // }


        },
        created() {
            // window.onbeforeunload = () => {
            //     socket.emit('leave', this.username);
            // }

            // socket.on('message', (data) => {
            //     this.messages.push({
            //         message: data.message,
            //         account: data.account,
            //         conversation_uuid: data.conversation_uuid,
            //         liveagentToken: data.liveagentToken
            //     });

            //     this.conversations_list.push({
            //         username: data.username,
            //         userId: data.userId
            //     });
            // });
            this.conversations_list.push({
                    first_name: "Manoj Ganesan",
                    userId: "12345678",
                    date:"April 27 2021 PST 11:05 PM",
                    location:"NY USA"

                });
            // --> 

            // socket.on('message', (data) => {
            //     this.messages.push({
            //         message: data.message,
            //         account: data.account,
            //         conversation_uuid: data.conversation_uuid,
            //         liveagentToken: data.liveagentToken
            //     });
            // });

            // socket.on('chat_request_accept', (data) => {
            //     console.log("Chat Request Accepted", data);

            //     for (let i = 0; i < this.messages_requests.length; i++) {
            //         if (this.messages_requests[i].convo_id == data.convo_id) {
            //             let value = this.messages_requests.splice(i, 1);
            //             console.log("SPLICED ITEM", value);
            //             this.conversations_list.push(value[0]);
            //         }
            //     }
            // });

            this.messages_requests.push({
                    account: "data.account",
                    conversation_uuid: "data.conversation_uuid",
                    liveagentToken: "data.liveagentToken",
                    first_name: "Manoj",
                    last_name: "G",
                    convo_id: "123",
                    date:"April 27 2021 PST 11:05 PM",
                    location:"NY USA"
                });

            // socket.on('chat_request', (data) => {
            //     console.log("Chat Request Data", data);
            //     this.messages_requests.push({
            //         account: data.account,
            //         conversation_uuid: data.conversation_uuid,
            //         liveagentToken: data.liveagentToken,
            //         first_name: data.first_name,
            //         last_name: data.last_name,
            //         convo_id: data.conversation_id
            //     });
            //     console.log("Chat Request messages_requests", this.messages_requests);
            // });

            socket.on('connections', (data) => {
                this.connections = data;
            });
        },


        watch: {
            newMessage(value) {
                value ? socket.emit('typing', this.username) : socket.emit('stopTyping')
            }
        },
        methods: {
            updateSelected(selectedItem) {
                console.log("selectedItem",selectedItem);
                // this.selectedChat = selectedItem;
                // this.showPlaces = true;
                this.agentConsole = false;
              //  let x =[{first_name:'manoj',date:"",location:'',msg:[{}]}]
                this.tempMsg = selectedItem
            },
            // dis:function(e){
            //     this.display="flex";

            // },
            dis(){
                var btn_div = document.getElementById('btn_div');
                console.log("DISPLAY FUNCTION")
                btn_div.style.display="flex";
                },
            openMod(){
                console.log("IN OPEN MODAL");
                document.getElementById('simpleModal').style.display='block';
                console.log("IN END OF OPEN MODAL");
            },
            closeModal(){
                console.log("IN OPEN MODAL");
                document.getElementById('simpleModal').style.display='none';
                console.log("IN END OF OPEN MODAL");

            },
            send() {
                
                this.tempMsg.push({'msg':this.newMessage,'type':'user'});
                this.newMessage ='';
                console.log('checkMsg',this.tempMsg);
            },
            closeButton(){
                this.agentConsole = true;
            },

            // send() {
            //     socket.emit('chat_message', {
            //         message: this.newMessage,
            //         user: this.username,
            //         conversation_uuid: this.conversation_uuid,
            //         conversation_id: this.conversation_id
            //     });
            // },

            // post_message: function () {
            //     fetch(`/api/conversations/${this.convoId}/postMessage`, {
            //         method: 'POST',
            //         headers: {
            //             'Content-Type': 'application/json',
            //             'Access-Token': `${this.accessToken}`
            //         }
            //     }).then((res) => {
            //         //message push in the list 1
            //         socket.emit('chat_message', {
            //             message: this.newMessage,
            //             user: this.username,
            //             conversation_uuid: this.conversation_uuid,
            //             conversation_id: this.conversation_id
            //         });
            //         return res.json();
            //     })
            // },

            acceptChat: function (e,i,item) {
               // alert(e);
                console.log("i",i,"\nitem:",item);
               this.conversations_list.push(item);
               this.messages_requests.splice(i,1);
               // console.log(e)
                // console.log(e.currentTarget)
                // console.log(e.target.parentElement);
                // console.log(e.target.parentElement.children);
                console.log(e.target.parentNode.id);
                console.log(e.target.parentNode.id);
                console.log(typeof e.target.parentNode.id)

                fetch(`/api/conversations/${e.target.parentNode.id}/acceptChat`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                        'Access-Token': '0bd20256-4923-46b2-9efa-73599a605b10'
                    }
                }).then((res) => {
                    //message push in the list 1
                    console.log('acceptChat==>', res);
                    return res.json();
                })
            },

            listOfChatRequest: function () {
                let accountId = '6012a7a69c497f0019500484';
                let self = this;
                fetch(`/api/conversations/${accountId}/list`, {
                    method: 'GET',
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }).then((res) => {
                    return res.json();
                }).then(data => {
                    // console.log("DATA========++>>>>>>>", data);
                    console.log("DATA========1++>>>>>>>", data);
                    // console.log("DATA========2++>>>>>>>", data[1]);
                    self.newRequests = data;
                });
            },

            // endChat: function () {
            //     fetch(`/api/conversations/${this.convoId}/endChat`, {
            //         method: 'POST',
            //         headers: {
            //             'Content-Type': 'application/json'
            //         }
            //     }).then((res) => {
            //         //message push in the list 2
            //         return res.json();
            //     })
            // }
        },
        beforeMount() {
            this.listOfChatRequest()
        }
    });

</script>

</html>